Index: LMDZ6/branches/Portage_acc/libf/phylmd/wake.F90
===================================================================
--- LMDZ6/branches/Portage_acc/libf/phylmd/wake.F90	(revision 4445)
+++ LMDZ6/branches/Portage_acc/libf/phylmd/wake.F90	(revision 4446)
@@ -7,10 +7,10 @@
                 dtdwn, dqdwn, amdwn, amup, dta, dqa, wgen, &
                 sigd_con, Cin, &
-                deltatw, deltaqw, sigmaw, awdens, wdens, &                  ! state variables
+                deltatw, deltaqw, sigmaw, awdens, wdens, &                  ! state variables           
                 dth, hw, wape, fip, gfl, &
                 dtls, dqls, ktopw, omgbdth, dp_omgb, tu, qu, &
                 dtke, dqke, omg, dp_deltomg, wkspread, cstar, &
-                d_deltat_gw, &
-                d_deltatw2, d_deltaqw2, d_sigmaw2, d_awdens2, d_wdens2)     ! tendencies
+                d_deltat_gw, &                                                      ! tendencies
+                d_deltatw2, d_deltaqw2, d_sigmaw2, d_awdens2, d_wdens2)             ! tendencies
 
 
@@ -27,8 +27,9 @@
   USE wake_ini_mod , ONLY : wake_ini
   USE wake_ini_mod , ONLY : prt_level,epsim1,RG,RD
-  USE wake_ini_mod , ONLY : stark, wdens_ref, coefgw, alpk, wdens_ref, stark, coefgw, alpk
+  USE wake_ini_mod , ONLY : stark, wdens_ref, coefgw, alpk, pupperbyphs
   USE wake_ini_mod , ONLY : crep_upper, crep_sol, tau_cv, rzero, aa0, flag_wk_check_trgl
   USE wake_ini_mod , ONLY : iflag_wk_act, iflag_wk_check_trgl, iflag_wk_pop_dyn, wdensmin
   USE wake_ini_mod , ONLY : sigmad, hwmin, wapecut, cstart, sigmaw_max, dens_rate, epsilon_loc
+  USE wake_ini_mod , ONLY : iflag_wk_profile
 
 
@@ -119,10 +120,10 @@
   ! wdens_ref: initial number of wakes per unit area (3D) or per
   ! unit length (2D), at the beginning of each time step
-  ! Tgw    : 1 sur la période de onde de gravité
-  ! Cgw    : vitesse de propagation de onde de gravité
+  ! Tgw    : 1 sur la periode de onde de gravite
+  ! Cgw    : vitesse de propagation de onde de gravite
   ! LL     : distance entre 2 poches
 
   ! -------------------------------------------------------------------------
-  ! Déclaration de variables
+  ! Declaration de variables
   ! -------------------------------------------------------------------------
 
@@ -163,8 +164,9 @@
   REAL, DIMENSION (klon, klev),     INTENT(OUT)         :: omgbdth, omg
   REAL, DIMENSION (klon, klev),     INTENT(OUT)         :: dp_omgb, dp_deltomg
-  REAL, DIMENSION (klon, klev),     INTENT(OUT)         :: d_deltat_gw
   REAL, DIMENSION (klon),           INTENT(OUT)         :: hw, wape, fip, gfl, cstar
   INTEGER, DIMENSION (klon),        INTENT(OUT)         :: ktopw
-  ! Tendencies of state variables
+  ! Tendencies of state variables (2 is appended to the names of fields which are the cumul of fields 
+  !                                 computed at each sub-timestep; e.g. d_wdens2 is the cumul of d_wdens)
+  REAL, DIMENSION (klon, klev),     INTENT(OUT)         :: d_deltat_gw
   REAL, DIMENSION (klon, klev),     INTENT(OUT)         :: d_deltatw2, d_deltaqw2
   REAL, DIMENSION (klon),           INTENT(OUT)         :: d_sigmaw2, d_awdens2, d_wdens2
@@ -173,5 +175,5 @@
   ! -------------------
 
-  ! Variables à fixer
+  ! Variables a fixer
 
   REAL                                                  :: delta_t_min
@@ -188,14 +190,22 @@
 !!  REAL, DIMENSION (klon)                                :: sigmaw1
 
-  ! Variables liees a la dynamique de population
+  ! Variables liees a la dynamique de population 1
   REAL, DIMENSION(klon)                                 :: act
   REAL, DIMENSION(klon)                                 :: rad_wk, tau_wk_inv
   REAL, DIMENSION(klon)                                 :: f_shear
   REAL, DIMENSION(klon)                                 :: drdt
-  REAL, DIMENSION(klon)                                 :: d_sig_gen, d_sig_death, d_sig_col
+  
+  ! Variables liees a la dynamique de population 2
+  REAL, DIMENSION(klon)                                 :: cont_fact  
+  
+!!  REAL, DIMENSION(klon)                                 :: d_sig_gen, d_sig_death, d_sig_col
   REAL, DIMENSION(klon)                                 :: wape1_act, wape2_act
   LOGICAL, DIMENSION (klon)                             :: kill_wake
   REAL                                                  :: drdt_pos
   REAL                                                  :: tau_wk_inv_min
+  ! Some components of the tendencies of state variables  
+  REAL, DIMENSION (klon)                                :: d_sig_gen2, d_sig_death2, d_sig_col2, d_sig_spread2, d_sig_bnd2
+  REAL, DIMENSION (klon)                                :: d_dens_gen2, d_dens_death2, d_dens_col2, d_dens_bnd2
+  REAL, DIMENSION (klon)                                :: d_adens_death2, d_adens_icol2, d_adens_acol2, d_adens_bnd2
 
   ! Variables pour les GW
@@ -219,6 +229,9 @@
   REAL, DIMENSION (klon, klev)                          :: d_deltatw, d_deltaqw
   REAL, DIMENSION (klon, klev)                          :: d_tenv, d_qe
-  REAL, DIMENSION (klon)                                :: d_awdens, d_wdens
-  REAL, DIMENSION (klon)                                :: d_sigmaw, alpha
+  REAL, DIMENSION (klon)                                :: d_awdens, d_wdens, d_sigmaw 
+  REAL, DIMENSION (klon)                                :: d_sig_gen, d_sig_death, d_sig_col, d_sig_spread, d_sig_bnd
+  REAL, DIMENSION (klon)                                :: d_dens_gen, d_dens_death, d_dens_col, d_dens_bnd
+  REAL, DIMENSION (klon)                                :: d_adens_death, d_adens_icol, d_adens_acol, d_adens_bnd
+  REAL, DIMENSION (klon)                                :: alpha, alpha_tot
   REAL, DIMENSION (klon)                                :: q0_min, q1_min
   LOGICAL, DIMENSION (klon)                             :: wk_adv, ok_qx_qw
@@ -227,6 +240,8 @@
   INTEGER                                               ::isubstep, k, i, igout
 
+  REAL                                                  :: sigmaw_targ
   REAL                                                  :: wdens_targ
-  REAL                                                  :: sigmaw_targ
+  REAL                                                  :: d_sigmaw_targ
+  REAL                                                  :: d_wdens_targ
 
   REAL, DIMENSION (klon)                                :: sum_thu, sum_tu, sum_qu, sum_thvu
@@ -276,5 +291,4 @@
   REAL, DIMENSION(klon)                                 :: awdens_in, wdens_in   ! pour les prints
 
-
   ! -------------------------------------------------------------------------
   ! Initialisations
@@ -289,7 +303,7 @@
   ! Configuration de coefgw,stark,wdens (22/02/06 by YU Jingmei)
 
-  ! coefgw : Coefficient pour les ondes de gravité
+  ! coefgw : Coefficient pour les ondes de gravite
   ! stark : Coefficient k dans Cstar=k*sqrt(2*WAPE)
-  ! wdens : Densité surfacique de poche froide
+  ! wdens : Densite surfacique de poche froide
   ! -------------------------------------------------------------------------
 
@@ -304,6 +318,5 @@
   ! alpk = 0.5
   ! alpk = 0.05
-
-
+!print *,'XXXX dtime input ', dtime
  igout = klon/2+1/klon
 
@@ -380,33 +393,4 @@
    sigmaw_in(:) = sigmaw(:)
 !>jyg
-
-  ! sigmaw1=sigmaw
-  ! IF (sigd_con.GT.sigmaw1) THEN
-  ! print*, 'sigmaw,sigd_con', sigmaw, sigd_con
-  ! ENDIF
-  IF (iflag_wk_pop_dyn >=1) THEN
-    DO i = 1, klon
-      wdens_targ = max(wdens(i),wdensmin)
-      d_wdens2(i) = wdens_targ - wdens(i)
-      wdens(i) = wdens_targ
-    END DO
-  ELSE
-    DO i = 1, klon
-      d_awdens2(i) = 0.
-      d_wdens2(i) = 0.
-    END DO
-  ENDIF  ! (iflag_wk_pop_dyn >=1)
-!
-  DO i = 1, klon
-    ! c      sigmaw(i) = amax1(sigmaw(i),sigd_con(i))
-!jyg<
-!!    sigmaw(i) = amax1(sigmaw(i), sigmad)
-!!    sigmaw(i) = amin1(sigmaw(i), 0.99)
-    sigmaw_targ = min(max(sigmaw(i), sigmad),0.99)
-    d_sigmaw2(i) = sigmaw_targ - sigmaw(i)
-    sigmaw(i) = sigmaw_targ
-!>jyg
-  END DO
-
 !
   IF (iflag_wk_pop_dyn >= 1) THEN
@@ -417,4 +401,57 @@
 !!  ELSE
   ENDIF  ! (iflag_wk_pop_dyn >= 1)
+
+
+  ! sigmaw1=sigmaw
+  ! IF (sigd_con.GT.sigmaw1) THEN
+  ! print*, 'sigmaw,sigd_con', sigmaw, sigd_con
+  ! ENDIF
+  IF (iflag_wk_pop_dyn >= 1) THEN
+    DO i = 1, klon
+      d_dens_gen2(i)   = 0.
+      d_dens_death2(i) = 0.
+      d_dens_col2(i)   = 0.
+      d_awdens2(i) = 0.
+!
+      wdens_targ = max(wdens(i),wdensmin)
+      d_dens_bnd2(i) = wdens_targ - wdens(i)
+      d_wdens2(i) = wdens_targ - wdens(i)
+      wdens(i) = wdens_targ
+    END DO
+    IF (iflag_wk_pop_dyn == 2) THEN
+       DO i = 1, klon  
+          d_adens_death2(i) = 0.
+          d_adens_icol2(i) = 0.
+          d_adens_acol2(i) = 0.
+!      
+          wdens_targ = min(max(awdens(i),0.),wdens(i))
+          d_adens_bnd2(i) = wdens_targ - awdens(i)
+          d_awdens2(i) = wdens_targ - awdens(i)
+          awdens(i) = wdens_targ
+       END DO
+    ENDIF ! (iflag_wk_pop_dyn == 2)
+  ELSE  
+    DO i = 1, klon
+      d_awdens2(i) = 0.
+      d_wdens2(i) = 0.
+    END DO
+  ENDIF  ! (iflag_wk_pop_dyn >= 1)
+!
+  DO i = 1, klon
+    ! c      sigmaw(i) = amax1(sigmaw(i),sigd_con(i))
+!jyg<
+!!    sigmaw(i) = amax1(sigmaw(i), sigmad)
+!!    sigmaw(i) = amin1(sigmaw(i), 0.99)
+    d_sig_gen2(i)   = 0.
+    d_sig_death2(i) = 0.
+    d_sig_col2(i)   = 0.
+    d_sig_spread2(i)= 0.
+    sigmaw_targ = min(max(sigmaw(i), sigmad),0.99)
+    d_sig_bnd2(i) = sigmaw_targ - sigmaw(i)
+    d_sigmaw2(i) = sigmaw_targ - sigmaw(i)
+!  print *,'XXXX1 d_sigmaw2(i), sigmaw(i) ', d_sigmaw2(i), sigmaw(i)
+    sigmaw(i) = sigmaw_targ
+!>jyg
+  END DO
 
   wape(:) = 0.
@@ -446,4 +483,5 @@
 dp_omgbw(:,:) = 0.
 omgbdq(:,:) = 0.
+
 !>jyg
 !
@@ -572,17 +610,7 @@
   END DO
 
-
+  
   ! Choose an integration bound well above wake top
   ! -----------------------------------------------------------------
-
-  ! Pupper = 50000.  ! melting level
-  ! Pupper = 60000.
-  ! Pupper = 80000.  ! essais pour case_e
-  DO i = 1, klon
-    pupper(i) = 0.6*ph(i, 1)
-    pupper(i) = max(pupper(i), 45000.)
-    ! cc        Pupper(i) = 60000.
-  END DO
-
 
   ! Determine Wake top pressure (Ptop) from buoyancy integral
@@ -657,16 +685,13 @@
   ! -5/ Determination de ktop et kupper
 
+  CALL pkupper (klon, klev, ptop, ph, pupper, kupper)
+  
   DO k = klev, 1, -1
     DO i = 1, klon
       IF (ph(i,k+1)<ptop(i)) ktop(i) = k
-      IF (ph(i,k+1)<pupper(i)) kupper(i) = k
-    END DO
-  END DO
-
-  ! On evite kupper = 1 et kupper = klev
-  DO i = 1, klon
-    kupper(i) = max(kupper(i), 2)
-    kupper(i) = min(kupper(i), klev-1)
-  END DO
+    END DO
+  END DO
+  !print*, 'ptop, pupper, ktop, kupper', ptop, pupper, ktop, kupper
+ 
 
 
@@ -808,5 +833,7 @@
 !!      sigmaw(i) = amax1(sigmad, sigd_con(i))
       sigmaw_targ = max(sigmad, sigd_con(i))
+      d_sig_bnd2(i) = d_sig_bnd2(i) + sigmaw_targ - sigmaw(i)
       d_sigmaw2(i) = d_sigmaw2(i) + sigmaw_targ - sigmaw(i)
+!  print *,'XXXX2 d_sigmaw2(i), sigmaw(i) ', d_sigmaw2(i), sigmaw(i)
       sigmaw(i) = sigmaw_targ
 !>jyg
@@ -840,4 +867,5 @@
     ok_qx_qw(i) = q0_min(i) >= 0.
     alpha(i) = 1.
+    alpha_tot(i) = 1.
   END DO
 
@@ -855,7 +883,12 @@
   dtimesub = dtime/nsub
 
+
+  
   ! ------------------------------------------------------------
   DO isubstep = 1, nsub
     ! ------------------------------------------------------------
+  CALL pkupper (klon, klev, ptop, ph, pupper, kupper)
+ 
+    !print*, 'ptop, pupper, ktop, kupper', ptop, pupper, ktop, kupper
 
     ! wk_adv is the logical flag enabling wake evolution in the time advance
@@ -867,9 +900,10 @@
       PRINT *, 'wake-4.1, isubstep,wk_adv(igout),cstar(igout),wape(igout), ptop(igout) ', &
                           isubstep,wk_adv(igout),cstar(igout),wape(igout), ptop(igout)
+     
     ENDIF
 
     ! cc nrlmd   Ajout d'un recalcul de wdens dans le cas d'un entrainement
-    ! négatif de ktop à kupper --------
-    ! cc           On calcule pour cela une densité wdens0 pour laquelle on
+    ! negatif de ktop a kupper --------
+    ! cc           On calcule pour cela une densite wdens0 pour laquelle on
     ! aurait un entrainement nul ---
     !jyg<
@@ -878,5 +912,5 @@
     ! des descentes unsaturees. Nous faisons alors l'hypothese que la 
     ! convection profonde cree directement de nouvelles poches, sans passer 
-    ! par les thermiques. La nouvelle valeur de wdens est alors imposée.
+    ! par les thermiques. La nouvelle valeur de wdens est alors imposee.
 
     DO i = 1, klon
@@ -884,6 +918,10 @@
       ! c     $           isubstep,wk_adv(i),cstar(i),wape(i)
       IF (wk_adv(i) .AND. cstar(i)>0.01) THEN
-        omg(i, kupper(i)+1) = -RG*amdwn(i, kupper(i)+1)/sigmaw(i) + &
+        IF ( iflag_wk_profile == 0 ) THEN
+           omg(i, kupper(i)+1)=-RG*amdwn(i, kupper(i)+1)/sigmaw(i) + &
                                RG*amup(i, kupper(i)+1)/(1.-sigmaw(i))
+        ELSE
+           omg(i, kupper(i)+1)=0.
+        ENDIF
         wdens0 = (sigmaw(i)/(4.*3.14))* &
           ((1.-sigmaw(i))*omg(i,kupper(i)+1)/((ph(i,1)-pupper(i))*cstar(i)))**(2)
@@ -894,4 +932,5 @@
         IF (wdens(i)<=wdens0*1.1) THEN
           IF (iflag_wk_pop_dyn >= 1) THEN
+             d_dens_bnd2(i) = d_dens_bnd2(i) + wdens0 - wdens(i)
              d_wdens2(i) = d_wdens2(i) + wdens0 - wdens(i)
           ENDIF
@@ -908,5 +947,7 @@
 !!        sigmaw(i) = amin1(sigmaw(i), sigmaw_max)
         sigmaw_targ = min(sigmaw(i), sigmaw_max)
+        d_sig_bnd2(i) = d_sig_bnd2(i) + sigmaw_targ - sigmaw(i)
         d_sigmaw2(i) = d_sigmaw2(i) + sigmaw_targ - sigmaw(i)
+!  print *,'XXXX3 d_sigmaw2(i), sigmaw(i) ', d_sigmaw2(i), sigmaw(i)
         sigmaw(i) = sigmaw_targ
 !>jyg
@@ -914,68 +955,40 @@
     END DO
 
-    IF (iflag_wk_pop_dyn >= 1) THEN
+    IF (iflag_wk_pop_dyn == 1) THEN
+  
+     CALL wake_popdyn_1 (klon, klev, dtime, cstar, tau_wk_inv, wgen, wdens, awdens, sigmaw, &
+                  dtimesub, gfl, rad_wk, f_shear, drdt_pos, &
+                  d_awdens, d_wdens, d_sigmaw, &
+                  iflag_wk_act, wk_adv, cin, wape, &
+                  drdt, &
+                  d_dens_gen, d_dens_death, d_dens_col, d_dens_bnd, &
+                  d_sig_gen, d_sig_death, d_sig_col, d_sig_spread, d_sig_bnd, &
+                  d_wdens_targ, d_sigmaw_targ)
+                      
 !    The variable "death_rate" is significant only when iflag_wk_pop_dyn = 0.
 !    Here, it has to be set to zero.
       death_rate(:) = 0.
-
-      IF (iflag_wk_act ==2) THEN
+    
+    ELSEIF (iflag_wk_pop_dyn == 2) THEN
+     CALL wake_popdyn_2 ( klon, klev, wk_adv, dtimesub, wgen, &
+                             sigmaw, wdens, awdens, &   !! states variables
+                             gfl, cstar, cin, wape, rad_wk, &
+                             d_sigmaw, d_wdens, d_awdens, &  !! tendences                              
+                             cont_fact, &
+                             d_sig_gen, d_sig_death, d_sig_col, d_sig_spread, d_sig_bnd, &
+                             d_dens_gen, d_dens_death, d_dens_col, d_dens_bnd, &
+                             d_adens_death, d_adens_icol, d_adens_acol, d_adens_bnd )
+     death_rate(:) = 0.
+sigmaw=sigmaw-d_sigmaw
+wdens=wdens-d_wdens
+awdens=awdens-d_awdens
+   
+    ELSEIF (iflag_wk_pop_dyn == 0) THEN
+    
+    ! cc nrlmd
+
       DO i = 1, klon
         IF (wk_adv(i)) THEN
-          wape1_act(i) = abs(cin(i))
-          wape2_act(i) = 2.*wape1_act(i) + 1.
-          act(i) = min(1., max(0., (wape(i)-wape1_act(i)) / (wape2_act(i)-wape1_act(i)) ))
-        ENDIF  ! (wk_adv(i))
-      ENDDO
-      ENDIF  ! (iflag_wk_act ==2)
-
-
-      DO i = 1, klon
-        IF (wk_adv(i)) THEN
-!!          tau_wk(i) = max(rad_wk(i)/(3.*cstar(i))*((cstar(i)/cstart)**1.5 - 1), 100.)
-          tau_wk_inv(i) = max( (3.*cstar(i))/(rad_wk(i)*((cstar(i)/cstart)**1.5 - 1)), 0.)
-          tau_wk_inv_min = min(tau_wk_inv(i), 1./dtimesub)
-          drdt(i) = (cstar(i) - wgen(i)*(sigmaw(i)/wdens(i)-aa0)/gfl(i)) / &
-                    (1 + 2*f_shear(i)*(2.*sigmaw(i)-aa0*wdens(i)) - 2.*sigmaw(i))
-!!                    (1 - 2*sigmaw(i)*(1.-f_shear(i)))
-          drdt_pos=max(drdt(i),0.)
-
-!!          d_wdens(i) = ( wgen(i)*(1.+2.*(sigmaw(i)-sigmad)) &
-!!                     - wdens(i)*tau_wk_inv_min &
-!!                     - 2.*gfl(i)*wdens(i)*Cstar(i) )*dtimesub
-          d_awdens(i) = ( wgen(i) - (1./tau_cv)*(awdens(i) - act(i)*wdens(i)) )*dtimesub
-          d_wdens(i) = ( wgen(i) - (wdens(i)-awdens(i))*tau_wk_inv_min -  &
-                         2.*wdens(i)*gfl(i)*drdt_pos )*dtimesub
-          d_wdens(i) = max(d_wdens(i), wdensmin-wdens(i))
-
-!!          d_sigmaw(i) = ( (1.-2*f_shear(i)*sigmaw(i))*(gfl(i)*Cstar(i)+wgen(i)*sigmad/wdens(i)) &
-!!                      + 2.*f_shear(i)*wgen(i)*sigmaw(i)**2/wdens(i) &
-!!                      - sigmaw(i)*tau_wk_inv_min )*dtimesub
-          d_sig_gen(i) = wgen(i)*aa0
-          d_sig_death(i) = - sigmaw(i)*(1.-awdens(i)/wdens(i))*tau_wk_inv_min
-!!          d_sig_col(i) = - 2*f_shear(i)*sigmaw(i)*gfl(i)*drdt_pos
-          d_sig_col(i) = - 2*f_shear(i)*(2.*sigmaw(i)-wdens(i)*aa0)*gfl(i)*drdt_pos
-          d_sigmaw(i) = ( d_sig_gen(i) + d_sig_death(i) + d_sig_col(i) + gfl(i)*cstar(i) )*dtimesub
-          d_sigmaw(i) = max(d_sigmaw(i), sigmad-sigmaw(i))
-        ENDIF
-      ENDDO
-
-      IF (prt_level >= 10) THEN
-        print *,'wake, cstar(1), cstar(1)/cstart, rad_wk(1), tau_wk_inv(1), drdt(1) ', &
-                       cstar(1), cstar(1)/cstart, rad_wk(1), tau_wk_inv(1), drdt(1)
-        print *,'wake, wdens(1), awdens(1), act(1), d_awdens(1) ', &
-                       wdens(1), awdens(1), act(1), d_awdens(1)
-        print *,'wake, wgen, -(wdens-awdens)*tau_wk_inv, -2.*wdens*gfl*drdt_pos, d_wdens ', &
-                       wgen(1), -(wdens(1)-awdens(1))*tau_wk_inv(1), -2.*wdens(1)*gfl(1)*drdt_pos, d_wdens(1)
-        print *,'wake, d_sig_gen(1), d_sig_death(1), d_sig_col(1), d_sigmaw(1) ', &
-                       d_sig_gen(1), d_sig_death(1), d_sig_col(1), d_sigmaw(1)
-      ENDIF
-    
-    ELSE  !  (iflag_wk_pop_dyn >= 1)
-
-    ! cc nrlmd
-
-      DO i = 1, klon
-        IF (wk_adv(i)) THEN
-          ! cc nrlmd          Introduction du taux de mortalité des poches et
+          ! cc nrlmd          Introduction du taux de mortalite des poches et
           ! test sur sigmaw_max=0.4
           ! cc         d_sigmaw(i) = gfl(i)*Cstar(i)*dtimesub
@@ -1008,5 +1021,5 @@
     ! IM 060208 differences par rapport au code initial; init. a 0 dp_deltomg
     ! IM 060208 et omg sur les niveaux de 1 a klev+1, alors que avant l'on definit
-    ! IM 060208 au niveau k=1..?
+    ! IM 060208 au niveau k=1...
     !JYG 161013 Correction : maintenant omg est dimensionne a klev.
     DO k = 1, klev
@@ -1082,6 +1095,10 @@
     DO i = 1, klon
       IF (wk_adv(i) .AND. kupper(i)>ktop(i)) THEN
-        omg(i, kupper(i)+1) = -RG*amdwn(i, kupper(i)+1)/sigmaw(i) + &
+        IF ( iflag_wk_profile == 0 ) THEN
+           omg(i, kupper(i)+1) =-RG*amdwn(i, kupper(i)+1)/sigmaw(i) + &
           RG*amup(i, kupper(i)+1)/(1.-sigmaw(i))
+        ELSE
+           omg(i, kupper(i)+1) = 0.
+        ENDIF
         dp_deltomg(i, kupper(i)) = (omgtop(i)-omg(i,kupper(i)+1))/ &
           (ptop(i)-pupper(i))
@@ -1090,5 +1107,5 @@
 
     ! c      DO i=1,klon
-    ! c        print*,'Pente entre 0 et kupper (référence)'
+    ! c        print*,'Pente entre 0 et kupper (reference)'
     ! c     $   	,omg(i,kupper(i)+1)/(pupper(i)-ph(i,1))
     ! c        print*,'Pente entre ktop et kupper'
@@ -1166,4 +1183,5 @@
         IF (wk_adv(i) .AND. k<=kupper(i)+1) THEN
           dth(i, k) = deltatw(i, k)/ppi(i, k)
+! print *, 'VVVVwake k, the(i,k), dth(i,k), sigmaw(i) ', k, the(i,k), dth(i,k), sigmaw(i)
           th1(i, k) = the(i, k) - sigmaw(i)*dth(i, k) ! undisturbed area
           th2(i, k) = the(i, k) + (1.-sigmaw(i))*dth(i, k) ! wake
@@ -1214,9 +1232,10 @@
     END DO
 
-    IF (prt_level>=10) THEN
-      PRINT *, 'wake-4.3, th1(igout,k) ', (k,th1(igout,k), k=1,klev)
-      PRINT *, 'wake-4.3, th2(igout,k) ', (k,th2(igout,k), k=1,klev)
-      PRINT *, 'wake-4.3, dth(igout,k) ', (k,dth(igout,k), k=1,klev)
-      PRINT *, 'wake-4.3, omgbdth(igout,k) ', (k,omgbdth(igout,k), k=1,klev)
+!!    IF (prt_level>=10) THEN
+    IF (prt_level>=10 .and. wk_adv(igout)) THEN
+      PRINT *, 'wake-4.3, th1(igout,k) ', (k,th1(igout,k), k=1,kupper(igout))
+      PRINT *, 'wake-4.3, th2(igout,k) ', (k,th2(igout,k), k=1,kupper(igout))
+      PRINT *, 'wake-4.3, dth(igout,k) ', (k,dth(igout,k), k=1,kupper(igout))
+      PRINT *, 'wake-4.3, omgbdth(igout,k) ', (k,omgbdth(igout,k), k=1,kupper(igout))
     ENDIF
 
@@ -1310,5 +1329,5 @@
 
 
-          ! Coefficient de répartition
+          ! Coefficient de repartition
 
           crep(i, k) = crep_sol*(ph(i,kupper(i))-ph(i,k))/ &
@@ -1340,6 +1359,6 @@
 !
 
-          ! cc nrlmd          Prise en compte du taux de mortalité
-          ! cc               Définitions de entr, detr
+          ! cc nrlmd          Prise en compte du taux de mortalite
+          ! cc               Definitions de entr, detr
 !jyg<
 !!            detr(i, k) = 0.
@@ -1358,5 +1377,5 @@
 
 
-          ! ajout d'un effet onde de gravité -Tgw(k)*deltatw(k) 03/02/06 YU
+          ! ajout d'un effet onde de gravite -Tgw(k)*deltatw(k) 03/02/06 YU
           ! Jingmei
 
@@ -1414,4 +1433,11 @@
     CALL wake_vec_modulation(klon, klev, wk_adv, epsilon_loc, qe, d_qe, deltaqw, &
       d_deltaqw, sigmaw, d_sigmaw, alpha)
+    !
+    ! Alpha_tot = Product of all the alpha's
+    DO i = 1, klon
+      IF (wk_adv(i)) THEN
+        alpha_tot(i) = alpha_tot(i)*alpha(i)    
+      END IF
+    END DO
 
     ! cc nrlmd
@@ -1472,22 +1498,62 @@
         sigmaw(i) = sigmaw(i) + d_sigmaw(i)
         d_sigmaw2(i) = d_sigmaw2(i) + d_sigmaw(i)
+!  print *,'XXXX4 d_sigmaw2(i), sigmaw(i) ', d_sigmaw2(i), sigmaw(i)
       END IF
     END DO
 !jyg<
     IF (iflag_wk_pop_dyn >= 1) THEN
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! sigmaw !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+!  Cumulatives
+      DO i = 1, klon
+        IF (wk_adv(i)) THEN
+          d_sig_gen2(i)   = d_sig_gen2(i)   + d_sig_gen(i)
+          d_sig_death2(i) = d_sig_death2(i) + d_sig_death(i)
+          d_sig_col2(i)   = d_sig_col2(i)   + d_sig_col(i)
+          d_sig_spread2(i)= d_sig_spread2(i)+ d_sig_spread(i)
+          d_sig_bnd2(i)   = d_sig_bnd2(i)   + d_sig_bnd(i)
+        END IF
+      END DO
+!  Bounds
+      DO i = 1, klon
+        IF (wk_adv(i)) THEN
+          sigmaw_targ = max(sigmaw(i),sigmad)
+          d_sig_bnd2(i) = d_sig_bnd2(i) + sigmaw_targ - sigmaw(i)
+          d_sigmaw2(i) = d_sigmaw2(i) + sigmaw_targ - sigmaw(i)
+!  print *,'XXXX5 d_sigmaw2(i), sigmaw(i) ', d_sigmaw2(i), sigmaw(i)
+          sigmaw(i) = sigmaw_targ
+        END IF
+      END DO
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! wdens  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+!  Cumulatives
+      DO i = 1, klon
+        IF (wk_adv(i)) THEN
+          wdens(i) = wdens(i) + d_wdens(i)
+          d_wdens2(i) = d_wdens2(i) + d_wdens(i)
+          d_dens_gen2(i)   = d_dens_gen2(i)   + d_dens_gen(i)
+          d_dens_death2(i) = d_dens_death2(i) + d_dens_death(i)
+          d_dens_col2(i)   = d_dens_col2(i)   + d_dens_col(i)
+          d_dens_bnd2(i)   = d_dens_bnd2(i)   + d_dens_bnd(i)
+        END IF
+      END DO
+!  Bounds
+      DO i = 1, klon
+        IF (wk_adv(i)) THEN
+          wdens_targ = max(wdens(i),wdensmin)
+          d_dens_bnd2(i) = d_dens_bnd2(i) + wdens_targ - wdens(i)
+          d_wdens2(i) = d_wdens2(i) + wdens_targ - wdens(i)
+          wdens(i) = wdens_targ
+        END IF
+      END DO
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! awdens !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+!  Cumulatives
       DO i = 1, klon
         IF (wk_adv(i)) THEN
           awdens(i) = awdens(i) + d_awdens(i)
-          wdens(i) = wdens(i) + d_wdens(i)
           d_awdens2(i) = d_awdens2(i) + d_awdens(i)
-          d_wdens2(i) = d_wdens2(i) + d_wdens(i)
-        END IF
-      END DO
+        END IF
+      END DO
+!  Bounds
       DO i = 1, klon
         IF (wk_adv(i)) THEN
-          wdens_targ = max(wdens(i),wdensmin)
-          d_wdens2(i) = d_wdens2(i) + wdens_targ - wdens(i)
-          wdens(i) = wdens_targ
-!
           wdens_targ = min( max(awdens(i),0.), wdens(i) )
           d_awdens2(i) = d_awdens2(i) + wdens_targ - awdens(i)
@@ -1495,13 +1561,25 @@
         END IF
       END DO
-      DO i = 1, klon
-        IF (wk_adv(i)) THEN
-          sigmaw_targ = max(sigmaw(i),sigmad)
-          d_sigmaw2(i) = d_sigmaw2(i) + sigmaw_targ - sigmaw(i)
-          sigmaw(i) = sigmaw_targ
-        END IF
-      END DO
+!
+      IF (iflag_wk_pop_dyn == 2) THEN
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! awdens again for iflag_wk_pop_dyn = 2!!!!!!
+!  Cumulatives
+          DO i = 1, klon
+             IF (wk_adv(i)) THEN
+                 d_adens_death2(i)   = d_adens_death2(i)   + d_adens_death(i)
+                 d_adens_icol2(i)   = d_adens_icol2(i)   + d_adens_icol(i)
+                 d_adens_acol2(i)   = d_adens_acol2(i)   + d_adens_acol(i)
+                 d_adens_bnd2(i)   = d_adens_bnd2(i)   + d_adens_bnd(i)          
+             END IF
+          END DO
+!  Bounds
+          DO i = 1, klon
+             IF (wk_adv(i)) THEN
+                 wdens_targ = min( max(awdens(i),0.), wdens(i) )
+                 d_adens_bnd2(i) = d_adens_bnd2(i) + wdens_targ - awdens(i)
+             END IF
+          END DO
+      ENDIF ! (iflag_wk_pop_dyn == 2)
     ENDIF  ! (iflag_wk_pop_dyn >= 1)
-!>jyg
 
 
@@ -1744,5 +1822,7 @@
 !!          sigmaw(i) = max(sigmad, sigd_con(i))
           sigmaw_targ = max(sigmad, sigd_con(i))
+          d_sig_bnd2(i) = d_sig_bnd2(i) + sigmaw_targ - sigmaw(i)
           d_sigmaw2(i) = d_sigmaw2(i) + sigmaw_targ - sigmaw(i)
+!  print *,'XXXX6 d_sigmaw2(i), sigmaw(i) ', d_sigmaw2(i), sigmaw(i)
           sigmaw(i) = sigmaw_targ
 !>jyg
@@ -1961,5 +2041,7 @@
 !!      sigmaw(i) = amax1(sigmad, sigd_con(i))
       sigmaw_targ = max(sigmad, sigd_con(i))
+      d_sig_bnd2(i) = d_sig_bnd2(i) + sigmaw_targ - sigmaw(i)
       d_sigmaw2(i) = d_sigmaw2(i) + sigmaw_targ - sigmaw(i)
+!  print *,'XXXX7 d_sigmaw2(i), sigmaw(i) ', d_sigmaw2(i), sigmaw(i)
       sigmaw(i) = sigmaw_targ
 !>jyg
@@ -2058,5 +2140,8 @@
 !!      sigmaw(i) = 0.                        !jyg
       sigmaw_targ = 0.
-      d_sigmaw2(i) = d_sigmaw2(i) + sigmaw_targ - sigmaw(i)
+      d_sig_bnd2(i) = d_sig_bnd2(i) + sigmaw_targ - sigmaw(i)
+!!      d_sigmaw2(i) = d_sigmaw2(i) + sigmaw_targ - sigmaw(i)
+      d_sigmaw2(i) = sigmaw_targ - sigmaw_in(i)      ! _in = correction jyg 20220124
+!  print *,'XXXX8 d_sigmaw2(i), sigmaw(i) ', d_sigmaw2(i), sigmaw(i)
       sigmaw(i) = sigmaw_targ
       IF (iflag_wk_pop_dyn >= 1) THEN
@@ -2064,9 +2149,19 @@
 !!        wdens(i) = 0.
         wdens_targ = 0.
-        d_wdens2(i) = wdens_targ - wdens(i)
+        d_dens_bnd2(i) = d_dens_bnd2(i) + wdens_targ - wdens(i)
+!!        d_wdens2(i) = wdens_targ - wdens(i)
+        d_wdens2(i) = wdens_targ - wdens_in(i)      ! jyg 20220916
         wdens(i) = wdens_targ
         wdens_targ = 0.
-        d_awdens2(i) = wdens_targ - awdens(i)
+!!jyg: bug fix : the d_adens_bnd2 computation must be before the update of awdens.
+        IF (iflag_wk_pop_dyn == 2) THEN
+            d_adens_bnd2(i) = d_adens_bnd2(i) + wdens_targ - awdens(i)
+        ENDIF ! (iflag_wk_pop_dyn == 2)
+!!        d_awdens2(i) = wdens_targ - awdens(i)
+        d_awdens2(i) = wdens_targ - awdens_in(i)    ! jyg 20220916
         awdens(i) = wdens_targ
+!!        IF (iflag_wk_pop_dyn == 2) THEN
+!!            d_adens_bnd2(i) = d_adens_bnd2(i) + wdens_targ - awdens(i)
+!!        ENDIF ! (iflag_wk_pop_dyn == 2)
       ENDIF  ! (iflag_wk_pop_dyn >= 1)
     ELSE  ! (kill_wake(i))
@@ -2106,10 +2201,37 @@
     END DO
   END DO
-
-  DO i = 1, klon
+!jyg<
+  IF (iflag_wk_pop_dyn >= 1) THEN
+  DO i = 1, klon
+      IF (ok_qx_qw(i)) THEN
+    d_sig_gen2(i) = d_sig_gen2(i)/dtime
+    d_sig_death2(i) = d_sig_death2(i)/dtime
+    d_sig_col2(i) = d_sig_col2(i)/dtime
+    d_sig_spread2(i) = d_sig_spread2(i)/dtime
+    d_sig_bnd2(i) = d_sig_bnd2(i)/dtime
     d_sigmaw2(i) = d_sigmaw2(i)/dtime
+!  print *,'XXXX9 d_sigmaw2(i), sigmaw(i), dtime ', d_sigmaw2(i), sigmaw(i), dtime
+!
+    d_dens_gen2(i) = d_dens_gen2(i)/dtime
+    d_dens_death2(i) = d_dens_death2(i)/dtime
+    d_dens_col2(i) = d_dens_col2(i)/dtime
+    d_dens_bnd2(i) = d_dens_bnd2(i)/dtime
     d_awdens2(i) = d_awdens2(i)/dtime
     d_wdens2(i) = d_wdens2(i)/dtime
+      ENDIF
   ENDDO
+  IF (iflag_wk_pop_dyn == 2) THEN
+    DO i = 1, klon
+      IF (ok_qx_qw(i)) THEN
+    d_adens_death2(i) = d_adens_death2(i)/dtime
+    d_adens_icol2(i) = d_adens_icol2(i)/dtime
+    d_adens_acol2(i) = d_adens_acol2(i)/dtime
+    d_adens_bnd2(i) = d_adens_bnd2(i)/dtime
+      ENDIF
+    ENDDO
+   ENDIF ! (iflag_wk_pop_dyn == 2)  
+  ENDIF  ! (iflag_wk_pop_dyn >= 1)
+ 
+!>jyg
 
  RETURN
@@ -2161,5 +2283,5 @@
         discrim = b*b - 4.*a*c
         ! print*, 'x, a, b, c, discrim', x, a, b, c, discrim
-        IF (a+b>=0.) THEN !! Condition suffisante pour la positivité de ovap
+        IF (a+b>=0.) THEN !! Condition suffisante pour la positivite de ovap
           alpha1(i) = 1.
         ELSE
